//Delphi 7.0
{$APPTYPE CONSOLE}
uses Windows;
var
  hCOM   : cardinal;
  dcb    : TDCB;
  timeout: TCOMMTIMEOUTS;
  ovr    : TOverlapped;
  Stat   : ComStat;
  Errs   : DWORD;
  Event  : DWORD;
  lenn   : cardinal;
  s      : string;
  i      : integer;

function COMopen(PortName : PChar) : cardinal;
var
  handle : cardinal;
begin
  COMopen := 0;
  handle := createFile(PortName, (GENERIC_READ or GENERIC_WRITE), 0, nil, OPEN_EXISTING, 0, 0);
  if (handle=INVALID_HANDLE_VALUE) then  exit;
  setupComm(handle, 256, 256);
  if (getCommState(handle, dcb)=false) then  exit;
  dcb.BaudRate := CBR_9600;
  dcb.ByteSize := 8;
  dcb.Parity := NOPARITY;
  //dcb.StopBits := ONESTOPBIT;
  dcb.StopBits := TWOSTOPBITS;
  if (setCommState(handle, dcb)=false) then  exit;
  ovr.hEvent := createEvent(nil, false, false, nil);
  getCommTimeOuts(handle, timeout);
  timeout.ReadIntervalTimeout:=32        {4000 maxdword};
  timeout.ReadTotalTimeoutMultiplier:=0;
  timeout.ReadTotalTimeoutConstant:=32;  {4000}
  timeout.WriteTotalTimeoutMultiplier:=0;
  timeout.WriteTotalTimeoutConstant:=32; {4000}
  setCommTimeOuts(handle, timeout);
  COMopen := handle;
end;


procedure COMclose(handle : cardinal);
begin
  purgeComm(handle, (PURGE_TXABORT or PURGE_RXABORT or PURGE_TXCLEAR or PURGE_RXCLEAR));
  closeHandle(handle);
end;


function COMwrite(handle : cardinal;  ovr : pointer;  s : string) : integer;
begin
  COMwrite:=1;
  if (setCommMask(handle, (EV_BREAK or EV_ERR or EV_TXEMPTY))=false) then
  begin
    COMwrite:=2;
    exit;
  end;
  if (writeFile(handle, s[1], length(s), lenn, ovr{nil})=false) then
  begin
    COMwrite:=3;
    exit;
  end;
  if (waitCommEvent(handle, Event, ovr)=true) then
  begin
    if ((Event and EV_BREAK)<>0) then
    begin
      COMwrite:=4;
      exit;
    end;
    if ((Event and EV_ERR)<>0) then
    begin
      COMwrite:=5;
      exit;
    end;
    if ((Event and EV_TXEMPTY)<>0) then
      COMwrite := 0;
  end;
end;


function COMread(handle : cardinal;  ovr : pointer;  var s : string) : integer;
begin
  COMread := 1;
(*
  if (waitCommEvent(handle, Event, ovr)=true) then
  begin
    clearCommError(handle, Errs, @Stat);
    if ((Event and EV_BREAK)<>0) then
    begin
      COMread:=2;
      exit;
    end;
    if ((Event and EV_ERR)<>0) then
    begin
      COMread:=3;
      exit;
    end;
    if ((Event and EV_RXCHAR)<>0) then
    begin
    end;
    if ((Event and EV_RXFLAG)<>0) then
    begin
      //lenn := Stat.cbInQue;
      setLength(s,250);
      if (readFile(handle, s[1], 250, lenn, ovr)=true) then
      begin
        setLength(s,lenn);
        COMread:=0;
      end;
    end;
  end;
*)
  setLength(s,250);
  for i := 1 to 250 do  s[i] := #0;
  if (readFile(handle, s[1], 250, lenn, ovr)=true) then
    if lenn>0 then
    begin
      setLength(s,lenn);
      COMread:=0;
    end;
end;


begin
  write('input number COM [0..255]:');
  readln(s);
  repeat
    hCOM := COMopen(pchar('COM'+s));
    if (hCOM=0) then
    begin
      write('Error: COM'+s+' not open!'#13#10);
      sleep(500);
    end;
  until (hCOM<>0);
  writeln('connect!'#13#10#10'empty string is end');
  repeat
    {reading...}
    if (COMread(hCOM, @ovr, s)=0) then  write(s)
      else  write(#13#10'-Error: COM read-'#13#10);
    {writing...}
    write(#13#10'>');
    readln(s);
    if s<>'' then
    begin
      s:=s+#13#10;
      if (COMwrite(hCOM, @ovr, s)<>0) then  write(#13#10'-Error: COM write-'#13#10);
    end;
  until s='';
  COMclose(hCOM);
end.

